<?php

namespace App\Controllers;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use App\Models\UserModel;
use App\Models\RitmoCardiacoModel;
use App\Models\ActividadModel;
use App\Models\FrecuenciaRespiratoriaModel;
use App\Models\ResumenSuenoModel;
use App\Models\SaturacionModel;
use App\Libraries\Api; // Import library
use CodeIgniter\Controller;

class Home extends Controller
{
    public function index()
    {
        $actividadModel = new ActividadModel();
        $date1 = strtotime("now");
        $userModel = new UserModel();
        $currentDate = date("Y-m-d",strtotime(date('Y-m-d')."- 1 days")); 
        $updateData= false;
        $data['user'] = $userModel->orderBy('id_user', 'DESC')->findAll();
        $actData = $actividadModel->where('fecha >=',$currentDate . ' 00:00:01')
                    ->where('fecha <=',$currentDate . ' 23:59:59')
                    ->findAll();
        if(empty($actData)){
            foreach ($data['user'] as $user) {
                //var_dump($user); 
                $actividad = array('steps', 'calories', 'distance', 'floors');
                $api = new APi();
                
                    if(($date1 - strtotime($user["last_update"])) > 27700 ){
                        $user = $api->refreshToken($user);
                        $updateData= true;
                    }
                    if($user){
                        foreach ($actividad as $valor){
                            $api->actividad($user['token'],$user['id_user'],$currentDate,$valor);
                        }
                        if($updateData){
                            $userModel->where('id_user',$user['id_user'])
                                    ->set(['token' => $user['token'], 'refresh_token' => $user['refresh_token']])
                                    ->update();
                        }
                    }
                    
                
            }
        
        }
        return view('welcome_message');
    }

    public function frecuencia()
    {
        $date1 = strtotime("now");
        $userModel = new UserModel();
        $frecuenciaModel = new FrecuenciaRespiratoriaModel();
        $currentDate = date("Y-m-d",strtotime(date('Y-m-d')."- 1 days")); 
        $updateData= false;
        $data['user'] = $userModel->orderBy('id_user', 'DESC')->findAll();
        $actData = $frecuenciaModel->where('fecha >=',$currentDate . ' 00:00:01')
                    ->where('fecha <=',$currentDate . ' 23:59:59')
                    ->findAll();

        if(empty($actData)){
                foreach ($data['user'] as $user) {
                    
                    $api = new APi();
                
                        if(($date1 - strtotime($user["last_update"])) > 27700 ){
                            $user = $api->refreshToken($user);
                            $updateData= true;
                        }
                        if($user){
                            $api->frecuenciarespiratoria($user['token'],$user['id_user'],$currentDate);
                            if($updateData){
                                $userModel->where('id_user',$user['id_user'])
                                        ->set(['token' => $user['token'], 'refresh_token' => $user['refresh_token']])
                                        ->update();    
                            }
                        } 
                    }
                
            }
        
        return view('welcome_message');
    }

    public function ritmocardiaco()
    {
        $date1 = strtotime("now");
        $userModel = new UserModel();
        $ritmoModel = new RitmoCardiacoModel();
        $currentDate = date("Y-m-d",strtotime(date('Y-m-d')."- 1 days")); 
        $updateData= false;
        $data['user'] = $userModel->orderBy('id_user', 'DESC')->findAll();

        $actData = $ritmoModel->where('fecha >=',$currentDate . ' 00:00:01')
                    ->where('fecha <=',$currentDate . ' 23:59:59')
                    ->findAll();

        if(empty($actData)){
            foreach ($data['user'] as $user) {
                
                $api = new APi();
                
                    if(($date1 - strtotime($user["last_update"])) > 27700 ){
                        $user = $api->refreshToken($user);
                        $updateData= true;
                    }
                    if($user){
                        $api->ritmocardiaco($user['token'],$user['id_user'],$currentDate);
                        if($updateData){
                            $userModel->where('id_user',$user['id_user'])
                                    ->set(['token' => $user['token'], 'refresh_token' => $user['refresh_token']])
                                    ->update();    
                        }
                    } 
                }
            
        }
        return view('welcome_message');
    }

    public function saturacion()
    {
        $date1 = strtotime("now");
        $userModel = new UserModel();
        $saturacionModel = new SaturacionModel();
        $currentDate = date("Y-m-d",strtotime(date('Y-m-d')."- 1 days")); 
        $updateData= false;
        $data['user'] = $userModel->orderBy('id_user', 'DESC')->findAll();

        $actData = $saturacionModel->where('fechahora >=',$currentDate . ' 00:00:01')
                    ->where('fechahora <=',$currentDate . ' 23:59:59')
                    ->findAll();

        if(empty($actData)){
            foreach ($data['user'] as $user) {
                
                $api = new APi();
            
                    if(($date1 - strtotime($user["last_update"])) > 27700 ){
                        $user = $api->refreshToken($user);
                        $updateData= true;
                    }
                    if($user){
                        $api->saturacion($user['token'],$user['id_user'],$currentDate);
                        if($updateData){
                            $userModel->where('id_user',$user['id_user'])
                                    ->set(['token' => $user['token'], 'refresh_token' => $user['refresh_token']])
                                    ->update();    
                        }
                    } 
                }
            
        }
        return view('welcome_message');
    }

    public function resumensueno()
    {
        $date1 = strtotime("now");
        $userModel = new UserModel();
        $resumenSuenoModel = new ResumenSuenoModel();
        $currentDate = date("Y-m-d",strtotime(date('Y-m-d')."- 1 days")); 
        $updateData= false;
        $data['user'] = $userModel->orderBy('id_user', 'DESC')->findAll();

        $actData = $resumenSuenoModel->where('fecha >=',$currentDate . ' 00:00:01')
                    ->where('fecha <=',$currentDate . ' 23:59:59')
                    ->findAll();

        if(empty($actData)){
            foreach ($data['user'] as $user) {
                
                $api = new APi();
            
                    if(($date1 - strtotime($user["last_update"])) > 27700 ){
                        $user = $api->refreshToken($user);
                        $updateData= true;
                    }
                    if($user){
                        $api->resumensueno($user['token'],$user['id_user'],$currentDate);
                        if($updateData){
                            $userModel->where('id_user',$user['id_user'])
                                    ->set(['token' => $user['token'], 'refresh_token' => $user['refresh_token']])
                                    ->update();    
                        }
                    } 
                }
            
        }
        
        return view('welcome_message');
    }

    public function users()
    {
        $userModel = new UserModel();
        $data['data'] = $userModel->orderBy('id_user', 'DESC')->findAll();
        
        return $this->response->setJSON($data);
    }

    public function resumenDream()
    {
        $resumenModel = new ResumenSuenoModel();
        $data['data'] = $resumenModel->where('id_user',$this->request->getVar('id_user'))
        ->orderBy('id', 'DESC')->findAll();
        
        return $this->response->setJSON($data);
    }

}
